// functionDemo.cpp
#include <stdio.h>
#include "functionDemo.h"

int main(int argc, char* argv[])
{
	int i=5, j=7;
	printf("%d+%d=%d\n",i,j,add(i,j));

	int a=4, b=7;
	printf("\nSwapping call-by-value variables:");
	printf("\nBefore Swap: a=%d  b=%d",a,b);
	badSwap(a,b);
	printf("\nAfter Swap: a=%d  b=%d\n",a,b);

	a=4, b=7;
	printf("\nSwapping call-by-reference variables:");
	printf("\nBefore Swap: a=%d  b=%d",a,b);
	goodSwap(&a,&b);
	printf("\nAfter Swap: a=%d  b=%d\n",a,b);

	a=4, b=7;
	printf("\nSwapping pointers:");
	printf("\nBefore Swap: a=%d  b=%d",a,b);
	badSwap2(&a,&b);
	printf("\nAfter Swap: a=%d  b=%d\n",a,b);

	return 0;
}

int add(int a, int b){
	return a+b;
}


void badSwap(int a, int b)
{
	int temp;
	temp=a; a=b; b=temp;
	printf("\nInside Swap: a=%d  b=%d",a,b);
}

void goodSwap(int *aPtr, int *bPtr)
{
	int temp; 
	temp=*aPtr; *aPtr=*bPtr; *bPtr=temp;
	printf("\nInside Swap: a=%d  b=%d",*aPtr,*bPtr);
}

void badSwap2(int *aPtr, int *bPtr)
{
	int *tempPtr=NULL;
	tempPtr=aPtr; aPtr=bPtr; bPtr=tempPtr;
	printf("\nInside Swap: a=%d  b=%d",*aPtr,*bPtr);
}
